var dragonSegments = [...document.querySelectorAll(".dragon")];
dragonSegments.reverse();
var startPos = { x: window.innerWidth / 2, y: window.innerHeight / 2 };
var mouse = { x: startPos.x, y: startPos.y };
var speed = 0.6;
let root = document.documentElement;

let hue = Math.floor(Math.random() * 360);
let complementary = hue + 100;

root.style.setProperty("--hue", hue);
root.style.setProperty("--complementary", complementary);

dragonSegments.forEach((segment, index) => {
	segment.x = startPos.x;
	segment.y = startPos.y;

	let newHue = hue + index;
	segment.style.setProperty("--hue", newHue);
});

// set initial position
gsap.set(".dragon", {
	x: startPos.x,
	y: startPos.y,
	xPercent: -50,
	yPercent: -50
});

window.addEventListener("mousemove", (e) => {
	mouse.x = e.x;
	mouse.y = e.y;
});

window.addEventListener("touchmove", (e) => {
	var poke = e.changedTouches[0];
	mouse.x = poke.clientX;
	mouse.y = poke.clientY;
});

function trail(follower, leader) {
	follower.x += (leader.x - follower.x) * speed;
	follower.y += (leader.y - follower.y) * speed;

	gsap.set(follower, {
		x: follower.x,
		y: follower.y
	});
}

gsap.ticker.add(() => {
	dragonSegments.forEach((segment, i) => {
		let previousSegment = dragonSegments[i - 1];

		if (i === 0) {
			trail(segment, mouse);
		} else {
			trail(segment, previousSegment);
		}
	});
});